#include "def.h"
#include <map>
#include <deque>
#include <algorithm>
using namespace std;

#define	iround(x)  ((int)((x)>=0?(x)+0.5:(x)-0.5))



class DivideAndConquer
{
public:
	int numDimensions; // number of dimensions
	int *dimSizes; // dimensions size
	int numPoints; // bitslice size
	deque<int*> points; // the points

	DivideAndConquer();
	DivideAndConquer(char *infile);
	deque<int*> getSkylineBasic(int dimension);
	deque<int*> getSkylineBasic(deque<int*> points, int dimension);
	deque<int*> getSkylineMway(deque<int*> points, int dimension, int wsize);
	void printPoints(deque<int*> points);
	~DivideAndConquer();

protected:
	int getMedian(deque<int*> points);
	bool dominates(int *a, int *b);
	deque<int*> mergeBasic(deque<int*> S1, deque<int*> S2, int dimension);
};
