#include "cache_block.h"



CacheBlock::CacheBlock()
{
	this->id = 0;
	this->numDimensions = 0;
	this->numOMasks = 0;
	this->numPoints = 0;
	this->query = 0;
	this->omasks = 0;
	this->comparisonKey = 0;
}


CacheBlock::CacheBlock(int id, int *q, dbitset *o, int numDimensions, int numOMasks, int numPoints)
{
	this->id = id;
	this->numDimensions = numDimensions;
	this->numOMasks = numOMasks;
	this->numPoints = numPoints;
	query = new int[numDimensions];
	memcpy(query, q, numDimensions*sizeof(int));
	omasks = new boost::dynamic_bitset<>[numOMasks];
	for (int m = 0; m < numOMasks; m++)
		omasks[m] = o[m];
	comparisonKey = 0;
}


void CacheBlock::print()
{
	cout << "query point: ";
	for (int d = 0; d < numDimensions; d++)
		cout << query[d] << " ";
	cout << endl;
	for (int i = 0; i < numOMasks; i++)
	{
		cout << "orthant mask " << i << ": ";
		for (int p=0; p<numPoints; p++)
			cout << omasks[i][p];
		cout << endl;
	}
}


CacheBlock::~CacheBlock()
{
}

