#include "timing.h"
#include "dynamic_skyline.h"
#include "query_parser.h"



int main(int argc, char **argv)
{

	if (argc != 5)
	{
		cerr << "\nUsage: mainDynamicSkylines input_file query_file cache_size cpolicy\n" << endl;
		exit(1);
	}

	Timing* tim = new Timing();
	long duration = 0;
	int size = 0;
	dbitset res;
	QueryParser *qparser = new QueryParser(argv[2]);
	int *query;
	DynamicSkyline *ds = new DynamicSkyline(argv[1], atoi(argv[3]), atoi(argv[4]));
	bool cache = true;

	while ((query = qparser->getNextQuery()) != 0)
	{
		cout << "query:";
		for (int d = 0; d < qparser->numDimensions; d++)
			cout << " " << query[d];
		cout << endl;

		tim->startClock();
		res = ds->getDynamicSkylineCachingBitmap(query);
		duration = tim->stopClock();

		for (int j = 0; j < res.size(); j++)
			if (res[j])
				size++;
		cout << "size: " << size << "\t";
		//cout << ":" << res << endl;
		cout << "time elapsed: " << ((float)duration) << "\t";
		cout << "points pruned " << ds->pointsPruned << endl << endl;

		size = 0;
		delete[] query;
	}

	delete ds;
	delete tim;
	delete qparser;
}
