#include "naive.h"



Naive::Naive()
{
}


Naive::Naive(char *infile)
{
	fstream fin;
	fin.open(infile, ios::in);
	fin >> numDimensions; // read dimensionality

	// read dimension sizes
	dimSizes = new int[numDimensions];
	for (int d = 0; d < numDimensions; d++)
	{ 
		fin >> dimSizes[d];
		dimSizes[d]++;

		#ifdef DEBUG
		cout << dimSizes[d] << " ";
		#endif
	}
	#ifdef DEBUG
	cout << endl;
	#endif

	// read number of points
	fin >> numPoints; 

	// read points
	int* point;
	for (int p = 0; p < numPoints; p++)
	{
		point = new int[numDimensions];

		#ifdef DEBUG
		cout << "point " << p << ": ";
		#endif

		for (int d = 0; d < numDimensions; d++)
		{
			fin >> point[d];

			#ifdef DEBUG
			cout << point[d] << " ";
			#endif
		}
		points.push_back(point);

		#ifdef DEBUG
		cout << endl;
		#endif
	}
	fin.close();

	#ifdef DEBUG
	cout << "numDimensions=" << numDimensions << " numPoints=" << numPoints << endl;
	#endif
}


bool Naive::isDominatedBy(int* a, int* b)
{
	bool doit = false;
//	if ((a[0] == 2) && (a[1] == 7) && (a[2] == 6) && (a[3] == 6) && (a[4] == 2) && (a[5] == 4) && (a[6] == 3) && (a[7] == 5) && (a[8] == 4) && (a[9] == 5))
		//doit=true;


	//#ifdef DEBUG
if (doit) {
	cout << "is ";
	for (int d = 0; d < numDimensions; d++)
		cout << a[d] << " ";
	cout << " dominated by ";
	for (int d = 0; d < numDimensions; d++)
		cout << b[d] << " ";
}	//#endif

	bool check = false;
	for (int d = 0; d < numDimensions; d++)
	{
		if (a[d] < b[d])
		{
if (doit) {//			#ifdef DEBUG
			cout << " NO";
			cout <<  endl;
}//			#endif

			return false;
		}
		else if (a[d] > b[d])
			check = true;
	}

if (doit){//	#ifdef DEBUG
	if (check)
		cout << " YES";
	else
		cout << " NO";
	cout <<  endl;
}//	#endif

	return check;
}


vector<int*> Naive::getSkyline()
{
	#ifdef PRINT_RESULTS
	cout << endl << "Skyline naive method" << endl;
	#endif

	vector<int> inSkyline;
	vector<int*> skyline;
	for (int p = 0; p < points.size(); p++)
		inSkyline.push_back(1);

	//vector<int*>::iterator piter;
	//for (piter = points.begin(); piter != points.end(); ++piter)
	for (int p = 0; p < points.size(); p++)
	{
		for (int vs = 0; vs < points.size(); vs++)
		{
			//if (isDominatedBy((*piter), points[vs]))
			if (isDominatedBy(points[p], points[vs]))
			{
				//points.erase(piter);
				inSkyline[p] = 0;
				break;
			}
		}
	}

	for (int p = 0; p < points.size(); p++)
	{
		if (inSkyline[p] == 1)
			skyline.push_back(points[p]);
	}

	return skyline;
}


Naive::~Naive()
{
	delete[] dimSizes;
	for (int j = 0; j < numPoints; j++)
		delete[] points[j];
}
