#include "query_parser.h"



QueryParser::QueryParser(const char *inputfile)
{
	fin.open(inputfile, ios::in);
	fin >> numDimensions; // read dimensionality
	dimSizes = new int[numDimensions];
	for (int d = 0; d < numDimensions; d++) // read dimension sizes
		fin >> dimSizes[d];
	fin >> numQueries;
}


int* QueryParser::getNextQuery()
{
	int *query = 0;

	if (numQueries > 0)
	{
		query = new int[numDimensions];

		#ifdef DEBUG
		cout << "query: ";
		#endif

		for (int d = 0; d < numDimensions; d++)
		{
			fin >> query[d];

			#ifdef DEBUG
			cout << query[d] << " ";
			#endif

			if (query[d] > dimSizes[d])
			{
				cerr << "ERROR: query is not valid." << endl << endl;
				return 0;
			}
		}

		#ifdef DEBUG
		cout << endl;
		#endif

		numQueries--;
	}

	return query;
}


QueryParser::~QueryParser()
{
	delete[] dimSizes;
	fin.close();
}
